<?php
/*
Plugin Name: Extrainc
Plugin URI: http://www.somecoders.com/extrainc
Description: Allows for user specified files to be automatically included.  This prevents the need to edit the actual WordPress files and any errors due to upgrading (and overwriting your edits, casuing errors)
Version: 0.1b
Author: mck
Author URI: http://www.somecoders.com
*/
function extrainc_menu() 
{
    if (function_exists('add_options_page')) 
	{
		add_options_page('Extrainc', 'Extrainc', 8, basename(__FILE__), 'extrainc_admin');
    }
}
function extrainc_include()
{
	$file_list = @file(ABSPATH .'wp-content/plugins/extrainc/extrainc_include_list.txt');
	foreach($file_list as $v)
	{
		@include(ABSPATH . $v);
	}
}
function extrainc_update($list)
{
	$handle = fopen(ABSPATH .'wp-content/plugins/extrainc/extrainc_include_list.txt', 'w+');
	if(@fwrite($handle, $list, strlen($list)))
	{
		return true;
	}
	else
	{
		return false;
	}
}
function extrainc_list_current()
{
	$file_list = @file(ABSPATH .'wp-content/plugins/extrainc/extrainc_include_list.txt');
	foreach($file_list as $v)
	{
		echo($v);
	}
}
function extrainc_admin()
{
	if($_POST['extrainc_update'])
	{
		//status updater
		if(extrainc_update($_POST['extrainc_list']))
		{
			$extra_head = '<div id="message" class="updated fade"><p><strong>Include list saved.</strong></p></div>';
		}
		else
		{
			$extra_head = '<div id="message" class="updated fade"><p><strong>Include list NOT saved!  Try again.</strong></p></div>';
		}
	}
	else
	{
		$extra_head = '';
	}
		?>
		<?php echo($extra_head); ?>
		<div class="wrap">
		<h2>Extrainc</h2>
		<p>Your current list of your current list of files to be included, add new ones by seperating it with a new line.<br />
		   Filenames are automatically prefixed with your home dir, so doing wp-content/plugins/blah.php is correct (note that there is no slash at the beginning!)</p>
		<form method="post" action="">
		Files:<br />
		<textarea name="extrainc_list" cols="35" rows="2"><?php extrainc_list_current(); ?></textarea><br /><br />
		<input type='submit' name="extrainc_update" value='update list' />
		</form>
		</div>
		<?Php
}

add_action('init', 'extrainc_include');
add_action('admin_menu', 'extrainc_menu');
?>